#!/usr/bin/python
import sys
import time
import numpy as np
import matplotlib
#matplotlib.use('Agg')
import matplotlib.pyplot as plt
import csv
import scipy.ndimage.filters
import scipy.interpolate
import six
if six.PY2:
    import ConfigParser as ConfigParser
    cfg = ConfigParser.ConfigParser()
else:
    import configparser
    cfg = configparser.ConfigParser(inline_comment_prefixes=(';','#',))

cfg.read('tckit.conf')
cfg.sections()

if (len(sys.argv) <= 1):
    fn = cfg.get('main', 'data_filename')       # Read data input filename from config file
else:
    fn = sys.argv[1]                               # Read data input filename from command line arg

chart_name   = cfg.get('plot', 'chart_title')
ref_range    = float(cfg.get('main', 'reference_value'))
baseline_col = int(cfg.get('main', 'baseline_ref_column'))
axis_y_max   = float(cfg.get('plot', 'y_max'))
axis_y_min   = float(cfg.get('plot', 'y_min'))
axis_y_step  = float(cfg.get('plot', 'y_resolution'))
axis_y_label = cfg.get('plot', 'y_label')
axis_x_max   = float(cfg.get('plot', 'x_max'))
axis_x_min   = float(cfg.get('plot', 'x_min'))
axis_x_step  = float(cfg.get('plot', 'x_resolution'))
axis_x_label = cfg.get('plot', 'x_label')

dataset_name1 = cfg.get('main', 'dataset_name1')
dataset_name2 = cfg.get('main', 'dataset_name2')
dataset_name3 = cfg.get('main', 'dataset_name3')
dataset_name4 = cfg.get('main', 'dataset_name4')
dataset_name5 = cfg.get('main', 'dataset_name5')
dataset_name6 = cfg.get('main', 'dataset_name6')
dataset_name7 = cfg.get('main', 'dataset_name7')
dataset_name8 = cfg.get('main', 'dataset_name8')
dataset_name9 = cfg.get('main', 'dataset_name9')
dataset_name10 = cfg.get('main', 'dataset_name10')
dataset_name11 = cfg.get('main', 'dataset_name11')
dataset_name12 = cfg.get('main', 'dataset_name12')

dataset_color1 = cfg.get('plot', 'dataset_color1')
dataset_color2 = cfg.get('plot', 'dataset_color2')
dataset_color3 = cfg.get('plot', 'dataset_color3')
dataset_color4 = cfg.get('plot', 'dataset_color4')
dataset_color5 = cfg.get('plot', 'dataset_color5')
dataset_color6 = cfg.get('plot', 'dataset_color6')
dataset_color7 = cfg.get('plot', 'dataset_color7')
dataset_color8 = cfg.get('plot', 'dataset_color8')
dataset_color9 = cfg.get('plot', 'dataset_color9')
dataset_color10 = cfg.get('plot', 'dataset_color10')
dataset_color11 = cfg.get('plot', 'dataset_color11')
dataset_color12 = cfg.get('plot', 'dataset_color12')
    
mfc_name = "DUT"
meter_name = "3458A"
real_row = 2

#if len(sys.argv) < 2:
#    print("Need an argument! <file_name> [<data_row_number>] [<dut_name>] [<meter_name>]")
#    quit()
#
#if len(sys.argv) >= 3:
#    real_row = int(sys.argv[2])
#
#if len(sys.argv) >= 4:
#    chart_name = sys.argv[3]
#
#if len(sys.argv) == 5:
#    meter_name = sys.argv[4]
polyn = 1

ideal = []
real = []
real2 = []
real3 = []
real4 = []
real5 = []
temppv = []
corr = []
date = []
cnt = 0
polyz = []
alpha = []
beta = []
gain = []
tvalue = []
c1 = []
c2 = []
delta = []
cnx = []
zerotctemp = []
valzerotc = []

chop_samples = 0
print (baseline_col)
valcnt = 0

with open(fn) as csvfile:
    #global valcnt
    valcnt = sum(1 for row in csvfile)
csvfile.close()

with open(fn) as csvfile:
    spamreader = csv.reader(csvfile, delimiter=';', quotechar='|')
    is_first = True
    for row in spamreader:
        cnt = cnt + 1
        if is_first:
            is_first = False
            continue
        #print ("%f" % float(row[1]))
        if cnt <= chop_samples:
            continue
        else:
            cnx.append(cnt - (chop_samples+1))
            ideal.extend([float(row[baseline_col])])
            real.extend([float(row[9])]) #3458
            real2.extend([float(row[11])]) #3458b
            real3.extend([float(row[4])]) #8081
            real4.extend([float(row[5])]) #2182
            real5.extend([float(row[6])]) #8508
            temppv.extend([float(row[29])])
            #corr.extend([(float(row[2]) + float(row[6]) ) / 2])
            date.extend([row[0]])


        
# 3458A
#p = np.polyfit(real,ideal,1)
#pv = np.polyval(p,real)
diff = ideal #-pv
diff_ppm = ideal#(diff/ref_range)*1000000.0

#print diff
refval = 10.0534405

axis_y_label = axis_y_label + (" %.7f VDC" % refval)

for ic in range (0,len(ideal)):
    real3[ic] = ( ( (real[ic] / refval) - 1) * 1e6)
    real4[ic] = ( ( (real2[ic] / refval) - 1) * 1e6) - 0.7
    #print " %.4f C" % real[ic]
print (real3)
#print real3
# 3458B
#p2 = np.polyfit(real2,ideal,1)
#pv2 = np.polyval(p2,real2)
#diff2 = ideal-pv2
#diff_ppm2 = (diff2/ref_range)*1000000.0
# 8081

#p3 = np.polyfit(real3,ideal,polyn)
#pv3 = np.polyval(p3,real3)
#diff3 = ideal-pv3
#diff_ppm3 = (diff3/ref_range)*1000000.0
# 2182
#p4 = np.polyfit(real4,corr,1)
#pv4 = np.polyval(p4,real4)
#diff4 = corr-pv4
#diff_ppm4 = (diff4/ref_range)*1000000.0

# 8508a
#p5 = np.polyfit(real5,ideal,1)
#pv5 = np.polyval(p5,real5)
#diff5 = ideal-pv5
#diff_ppm5 = (diff5/ref_range)*1000000.0

#p6 = np.polyfit(real6,corr,1)
#pv6 = np.polyval(p6,real6)
#diff6 = corr-pv6
#diff_ppm6 = (diff6/ref_range)*1000000.0

# 3458B
#diffu2 = corr-pv2
#diffu_ppm2 = (diffu2/ref_range)*1000000.0


#corrected_source = (diff_ppm + diff_ppm2 + diff_ppm3) / 3
#print corrected_source

#diff_ppm3 = diff_ppm - diff_ppm2 #(diff3/10.0)*1000000.0
#diff_ppm6 = diff_ppm5 - diff_ppm #(diff3/10.0)*1000000.0
#diff_ppm7 = diff_ppm5 - diff_ppm3 #(diff3/10.0)*1000000.0

#diffn3 = ideal-pv3
#diff_ppmn3 = (diffn3/ref_range)*1000000.0
#diffn4 = ideal-pv4
#diff_ppmn4 = (diffn4/ref_range)*1000000.0

#diff_ppmn  = diff_ppm#(diff3/10.0)*1000000.0
#diff_ppmn2 = diff_ppm2#(diff3/10.0)*1000000.0
#diff_ppmn3 = diff_ppm - diff_ppm2# - diff_ppm#(diff3/10.0)*1000000.0
#diff_ppmn4 = diff_ppm4 - diff_ppm #(diff3/10.0)*1000000.0
#diff_ppmn5 = diff_ppm5 - diff_ppm #(diff3/10.0)*1000000.0
#diff_ppmn6 = diff_ppm6 - diff_ppm #(diff3/10.0)*1000000.0

inl_max = np.amax(diff_ppm)
inl_min = np.amin(diff_ppm)
inl_delta = inl_max - inl_min
inl_span = inl_delta / 2.0

#corr = (diff_ppm - diff_ppm2)

#diff_c1 = corr
#diff_c2 = diff_ppm - diff_ppm2

#print(chart_name + " INL Max: %f, Min %f" % (inl_max , inl_min))
#print(chart_name + " INL +-%f" % inl_span)

fig, ax = plt.subplots()
idx = 1

ax.patch.set_facecolor('#eeeeff')
ax.set_clip_on(False)

w = float(cfg.get('main', 'plot_w')) / 80
h = float(cfg.get('main', 'plot_h')) / 100
ws = float(cfg.get('main', 'plot_w_s')) / 80
hs = float(cfg.get('main', 'plot_h_s')) / 100
fig.set_size_inches(w,h)
plt.tight_layout(rect=[0.03, 0.03, 1.0, 0.98], w_pad=0, h_pad=0.5)                                # Reduce margins around the graph

tdelta = np.amax(temppv) - np.amin(temppv)
reftemp = 23.00
nominal = []
median = []

print ("Temperature min = %.3f , max = %.3f, delta = %.3f C" % (np.amin(temppv), np.amax(temppv), tdelta) )
print ("REF temp = %.3f C" % reftemp)
    
print ("\033[2J")                                           # Clear screen

#nominal = [9.999957591e+00, 9.999963348e+00, 0, 0, 1.000001420e+01, 9.999958800e+00, 9.515830000e-01, 0, 0]
nominal.append(np.mean(real[:30]))
polyz = np.polyfit(temppv, real, 2)
c2 = polyz[0]
c1 = polyz[1]
gain = polyz[2]
tvalue = (c2 * reftemp*reftemp + c1*reftemp + gain)
alpha  = ((c1 + 2*reftemp*c2) / tvalue*1e6 )
beta   = (c2 / tvalue*1e6 )
delta  = ((tvalue - nominal) / nominal * 1e6)
zerotctemp = (-alpha / 2 / beta + reftemp)
valzerotc  = (nominal + (zerotctemp) * c1 + (zerotctemp)*2*c2)
median     = (np.median(real3))

if (gain != 0):
    print ("\033[37;1m\r\nNominal       :", nominal)
    print ("Median        : %.8f" % median)
    print ("Column number : %d " % 9), polyz, "Total samples = %d" % len(real3)
    print ("c1            : %e" % c1)
    print ("c2            : %e" % c2)
    print ("g             : %e" % gain)
    print ("Value T23     : %.6f" % (tvalue))
    print ("\033[36;1mAlpha T23     : %.4f ppm/K       " % (alpha)),
    print ("Beta      : %.4f ppm/K/2                " % (beta)),
    print ("Delta T23 : %.3f ppm         \033[39;1m" % (delta))
    print ("\033[35;1mZero TC       : %.3f C \033[39;0m" % (zerotctemp)),
    print ("\033[32;1m          Delta ZeroTC : %.6f\033[39;0m" % (valzerotc))

filtered1 = scipy.ndimage.filters.gaussian_filter1d(real3,  sigma=2)
filtered2 = scipy.ndimage.filters.gaussian_filter1d(real4,  sigma=2)
#filtered2 = scipy.ndimage.filters.gaussian_filter1d(diff_ppm2, sigma=2)
#filtered3 = scipy.ndimage.filters.gaussian_filter1d(diff_ppm3, sigma=1)
#filtered4 = scipy.ndimage.filters.gaussian_filter1d(diff_ppm4, sigma=8)
#filtered5 = scipy.ndimage.filters.gaussian_filter1d(diff_ppm5, sigma=8)
#filteredu = scipy.ndimage.filters.gaussian_filter1d(diffu_ppm2, sigma=8)
#filtered6 = scipy.ndimage.filters.gaussian_filter1d(diff_ppm6, sigma=8)

#filteredn1 = scipy.ndimage.filters.uniform_filter1d(diff_ppmn, size=2)
#filteredn2 = scipy.ndimage.filters.uniform_filter1d(diff_ppmn2, size=2)
#filteredn3 = scipy.ndimage.filters.gaussian_filter1d(diff_ppmn3, sigma=4)
#filteredn4 = scipy.ndimage.filters.uniform_filter1d(diff_ppmn4, size=2)
#filteredn5 = scipy.ndimage.filters.uniform_filter1d(diff_ppmn5, size=2)
#filteredn6 = scipy.ndimage.filters.uniform_filter1d(diff_ppmn6, size=2)

#filtered6 = scipy.ndimage.filters.gaussian_filter1d(diff_ppm6, sigma=2)
#filtered6 = scipy.ndimage.filters.gaussian_filter1d(diff_ppm6, sigma=2)
#filtered7 = scipy.ndimage.filters.gaussian_filter1d(diff_ppm7, sigma=2)

#for diff_ppm in diff_ppms:
#ax.plot(ideal, diff_ppm)
print (dataset_color1)
ax.plot(temppv, filtered1, "#%s" % dataset_color1, label='Data %i' % (1), linestyle='-', marker="o", linewidth=0.1, markersize=1)
#ax.plot(temppv, filtered2, dataset_color2, label='Data %i' % (2), linewidth=2)
#ax.plot(ideal, filtered2, dataset_color2, label='Data %i' % (6), linewidth=1.0)
#ax.plot(ideal, filteredn3, dataset_color4, label='Data %i' % (2), linewidth=2.0)
#ax.plot(ideal, filtered3, dataset_color3, label='Data %i' % (3), linewidth=3.0)
#ax.plot(ideal, filtered4, dataset_color4, label='Data %i' % (4), linewidth=2.0)
#ax.plot(ideal, filtered5, dataset_color5, label='Data %i' % (5), linewidth=2.0)
#ax.plot(ideal, filtered6, dataset_color6, label='Data %i' % (6), linewidth=4.0)

#ax.plot(ideal, filteredn3, dataset_color3, label='Data %i' % (6), linewidth=2.0)

#ax.plot(ideal, filteredn1, dataset_color1, label='Data %i' % (1), linewidth=1.0, alpha=0.3)
#ax.plot(ideal, filteredn2, dataset_color2, label='Data %i' % (2), linewidth=1.0, alpha=0.3)
#ax.plot(ideal, filteredn3, dataset_color3, label='Data %i' % (3), linewidth=100.0, alpha=0.1)
##ax.plot(ideal, filteredn4, dataset_color4, label='Data %i' % (4), linewidth=1.0, alpha=0.3)
#ax.plot(ideal, filteredn5, dataset_color5, label='Data %i' % (5), linewidth=1.0, alpha=0.3)

#ax.plot(ideal, filteredn6, dataset_color6, label='Data %i' % (6), linewidth=4.0, alpha=0.2)
#ax.plot(ideal, filtered4, dataset_color4, label='Data %i' % (4), linewidth=2.0)
#ax.plot(ideal, filtered5, '#888888', label='Data %i' % (4), linewidth=3.0)
#ax.plot(ideal, filtered5, dataset_color3, label='Data %i' % (5), linewidth=2.0)
#ax.plot(ideal, filtered7, colors[6], label='Data %i' % (7), linewidth=2.0)
#    idx = idx + 1
#plt.text(-0.105, 1.01, "xDevs.com", fontsize=15)
#plt.text(-0.105, -1.11, "https://github.com/tin-/linkit", fontsize=13)

axis_y_min = np.amin(real3)
axis_y_max = np.amax(real3)
axis_y_step = (axis_y_max - axis_y_min) / 50
ax.axis([axis_x_min, axis_x_max, axis_y_min, axis_y_max])
ax.legend([dataset_name1, dataset_name2, dataset_name3])#, dataset_name4, dataset_name5])#, dataset_name6])
#, dataset_name7, dataset_name8, dataset_name9, dataset_name10, dataset_name11, dataset_name12
plt.text(0.08, -0.08,'xDevs.com | https://github.com/tin-/linkit',
    horizontalalignment='center',
    verticalalignment='center',
    transform = ax.transAxes)
plt.text(0.05, 0.08,'Points : %d' % valcnt,
    horizontalalignment='left',
    verticalalignment='top',
    transform = ax.transAxes)
plt.text(0.05, 0.04,'%s' % date[0],
    horizontalalignment='left',
    verticalalignment='top',
    transform = ax.transAxes)
plt.text(0.87, 0.04,'%s' % date[valcnt - 2],
    horizontalalignment='left',
    verticalalignment='top',
    transform = ax.transAxes)

tmin = np.amin(temppv)
tmax = np.amax(temppv)
temppp = tmax - 18
    
vmed = np.median(real)
vmin = np.amin(real3)# - vstep
vmax = np.amax(real3)# + vstep
sdev = np.std(real3) # SDEV
tempco = ((vmax - vmin) / temppp) 
    
stats = 6
legendlabel = []
legendlabel.append("X7000 TC")
bgclr = "#f3f3ff"
colors = ['#e6194b', '#f58231', '#1f5119', '#3cb44b', '#008080', '#4363d8', '#000076', '#911eb4', '#f032e6', '#00a68c', '#664433', '#1f38e3', '#ff0000', '#ec18a0', '#dbb201', '#1c2b33', '#003355', '#fc007f']

plt.text(0.02 + (stats * 0.062), 0.31, '%s' % (legendlabel[0]),
    horizontalalignment='left',
    verticalalignment='top',backgroundcolor=bgclr,
    transform = ax.transAxes, size=18, color=colors[stats])
plt.text(0.02 + (stats * 0.062), 0.26,'BOX_TC[%d] : %.3f ppm/$\degree$C' % (stats, tempco),
    horizontalalignment='left',
    verticalalignment='top',backgroundcolor=bgclr,
    transform = ax.transAxes, size=12, color=colors[stats])
plt.text(0.02 + (stats * 0.062), 0.22,'Sdev[%d] : %.3f ppm' % (stats, sdev),
    horizontalalignment='left',
    verticalalignment='top',backgroundcolor=bgclr,
    transform = ax.transAxes, size=12, color=colors[stats])
plt.text(0.02 + (stats * 0.062), 0.19,'Median-23[%d] : %.7f VDC' % (stats, vmed),
    horizontalalignment='left',
    verticalalignment='top',backgroundcolor=bgclr,
    transform = ax.transAxes, size=12, color=colors[stats])
plt.text(0.02 + (stats * 0.062), 0.16, 'Min[%d] : %.3f ppm' % (stats, vmin),
    horizontalalignment='left',
    verticalalignment='top', backgroundcolor=bgclr,
    transform = ax.transAxes, size=11, color=colors[stats])
plt.text(0.02 + (stats * 0.062), 0.13, 'Max[%d] : %.3f ppm' % (stats, vmax),
    horizontalalignment='left',
    verticalalignment='top', backgroundcolor=bgclr,
    transform = ax.transAxes, size=11, color=colors[stats])
plt.text(0.02 + (stats * 0.062), 0.10, '"Zero" TC : %.3f C' % ( zerotctemp ),
    horizontalalignment='left',
    verticalalignment='top',backgroundcolor=bgclr,
    transform = ax.transAxes, size=12, color=colors[stats])
plt.text(0.02 + (stats * 0.062), 0.07, 'Beta : %.3f ppm/K2' % ( beta ),
    horizontalalignment='left',
    verticalalignment='top',backgroundcolor=bgclr,
    transform = ax.transAxes, size=12, color=colors[stats])
plt.text(0.02 + (stats * 0.062), 0.04, 'Alpha : %.3f ppm/K' % ( alpha ),
    horizontalalignment='left',
    verticalalignment='top',backgroundcolor=bgclr,
    transform = ax.transAxes, size=12, color=colors[stats])

    
#plt.text(0.5, 0.05,'Polynom fit order = %d' % polyn,
#    horizontalalignment='left',
#    verticalalignment='top',
#    fontsize=14,
#    transform = ax.transAxes)
    
plt.xticks(fontname = "Arial")  # This argument will change the font.
plt.yticks(fontname = "Arial")  # This argument will change the font.
start, end = ax.get_ylim()
ax.yaxis.set_ticks(np.arange(start, end, axis_y_step))
startx, endx = ax.get_xlim()
plt.tick_params(axis='x', which='major', labelsize=14)
plt.tick_params(axis='y', which='major', labelsize=14)
ax.xaxis.set_ticks(np.arange(startx, endx, axis_x_step))

ax.set(xlabel=axis_x_label, ylabel=axis_y_label,
    title='%s' % (chart_name))
ax.grid()

fns = cfg.get('main', 'plot_out_filename').split(".")
plot_out_filename = fns[0] + ("_poly%d.png" % polyn)

fig.savefig(plot_out_filename, facecolor=fig.get_facecolor(), transparent=False)
ax.yaxis.set_ticks(np.arange(start, end, axis_y_step * 2))
plt.tight_layout(rect=[0.025, 0.025, 1.0, 0.98], w_pad=0, h_pad=0.5)                                # Reduce margins around the graph
figs = fig
figs.set_size_inches(ws,hs)
figs.savefig(cfg.get('main', 'plot_out_filename_small'), facecolor=figs.get_facecolor(), transparent=False)
plt.show()


